//---------------------------------------------------------------------------
// File: TMainForm.h
//
//  TDx_Sound_Library
//  Example5 - Notifications
//
// Date: 21st June, 2002
// Author: Darren John Dwyer
// Copyright: (c) 2002 Darren John Dwyer, All Rights Reserved.
//
// Description:
//
// This example shows how to setup Sound Buffer Notifications at specific
// byte-offsets within a DirectSound Buffer, then how to respond to the
// TDx_SoundNotify::OnNotify() and TDSBPositionNotify::OnNotify() events.
//
// Note: It appears DirectSound has a maximum limit of 60 notification
// positions per buffer.
//
//---------------------------------------------------------------------------
#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include "TDx_Sound.h"
#include "TDx_SoundBuffer.h"
#include "TDSBufferDesc.h"
#include "TDSCaps.h"
#include <vcl\ExtCtrls.hpp>
#include <vcl\FileCtrl.hpp>
#include "TDx_SoundNotify.h"
#include "TDSBPositionNotify.h"
#include <vcl\Dialogs.hpp>
//---------------------------------------------------------------------------
#define MAX_DEVICES 256
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:    // IDE-managed Components
    TListBox *DevicesListBox;
    TLabel *Label3;
    TDx_Sound *Dx_Sound1;
    TDx_SoundBuffer *Dx_SoundBuffer1;
    TDSBufferDesc *DSBufferDesc1;
    TBitBtn *ExitButton;
    TPanel *Panel1;
    TLabel *Label23;
    TFileListBox *FileListBox1;
    TLabel *Label2;
    TDriveComboBox *DriveComboBox1;
    TDirectoryListBox *DirectoryListBox1;
    TEdit *Edit1;
    TBitBtn *StopButton;
    TBitBtn *PlayButton;
    TPanel *Panel2;
    TLabel *PlayingLabel;
    TLabel *BufferPosLabel;
    TLabel *BufferSizeLabel;
    TLabel *NotCreatedLabel;
    TMemo *StatusMemo;
    TLabel *NotificationLabel;
    TBitBtn *ToggleButton;
    TLabel *StatusLabel;
    TBitBtn *ClearButton;
    TLabel *Label1;
    TLabel *Label4;
    TDx_SoundNotify *Dx_SoundNotify1;
    TDSBPositionNotify *DSBPositionNotify1;
    TCheckBox *LoopingCheckBox;
    void __fastcall Dx_SoundBuffer1BufferLost(TObject *Sender);
    void __fastcall Dx_Sound1Destroy(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall DevicesListBoxClick(TObject *Sender);
    void __fastcall PlayButtonClick(TObject *Sender);
    void __fastcall Dx_SoundBuffer1Create(TObject *Sender);
    void __fastcall Dx_SoundBuffer1Destroy(TObject *Sender);
    void __fastcall FileListBox1DblClick(TObject *Sender);
    void __fastcall StopButtonClick(TObject *Sender);
    void __fastcall ExitButtonClick(TObject *Sender);
    
    void __fastcall Dx_SoundNotify1Notify(TObject *Sender, int Value);
    
    
    void __fastcall Dx_SoundNotify1Create(TObject *Sender);
    void __fastcall Dx_SoundNotify1Destroy(TObject *Sender);
    
    void __fastcall ToggleButtonClick(TObject *Sender);
    void __fastcall ClearButtonClick(TObject *Sender);
    
    
    void __fastcall Dx_SoundNotify1Error(TObject *Sender, AnsiString TheFunction,
    AnsiString TheError, AnsiString TheErrorMessage);

    
    
    
    
    void __fastcall FormShow(TObject *Sender);
    void __fastcall FormHide(TObject *Sender);
        void __fastcall Dx_Sound1Create(TObject *Sender);
    
    
    
    
    
    
    void __fastcall DSBPositionNotify1Notify(TObject *pSender,
    int pNotification);
    
    
    
    void __fastcall Dx_SoundBuffer1Error(TObject *Sender, AnsiString Function,
    AnsiString Error, AnsiString ErrorMessage);
    void __fastcall Dx_Sound1Error(TObject *Sender, AnsiString Function,
    AnsiString Error, AnsiString ErrorMessage);
    
    void __fastcall Dx_Sound1DSEnumerate(TObject *Sender, GUID *Guid,
    AnsiString DriverDescription, AnsiString DriverModule, void *Context,
    bool &Finished);
private:    // User declarations
    TStringList*    KnownDevices;
    TStringList*    KnownModules;
    TList*            KnownGuids;
    AnsiString        LastFileName;

public:        // User declarations
    __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
